/*
 * Mupgrade.c
 *
 * Function supporting the backward compatibility for the codes
 * developed earlier
 *
 */

#include <assert.h>
#include <stdio.h>
#include "parti.h"


/*
 * build_translation_table
 * 
 * Builds a translation table in the old style using the
 * new data structures
 *
 */
TTABLE *build_translation_table( type,index_array,ndata)
     int type,ndata,*index_array;
{
  TTABLE   *trans_table;
  DSTABLE  *table; 
  
  trans_table         = (TTABLE *) malloc(sizeof(TTABLE));
  trans_table->type   = DISTRIBUTED; 
  trans_table->regptr = NULL; 
  trans_table->tabptr = BuildDistTable(index_array, ndata, 0.0, -1);
  
  return(trans_table);
}





TTABLE *init_ttable_with_proc(type,color,ndata)
     int type,ndata,*color;
{
  TTABLE  *trans_table;

  trans_table = (TTABLE *) malloc(sizeof(TTABLE));
  trans_table->type   = DISTRIBUTED; 
  trans_table->tabptr = InitDistTable(color, ndata);

  return trans_table;
}





int   trans_table_size( ttable )
     TTABLE  *ttable ;
{
  return(tableGetPageSize(ttable));
}




int   *trans_table_color( ttable )
     TTABLE  *ttable ;
{
  int *procs,i, mysize ;

  if ( ttable->type == DISTRIBUTED ) {
     return ( ttable->tabptr->pageTable[PARTI_mynode]->Proc);
  } 
  else if ( ttable->type == REGULAR ) {
      mysize =  tableGetIndexCount(ttable);
      procs = (int *)malloc(sizeof(int)*mysize);
      for ( i=0; i< mysize; i++ ) {
        procs[i] = PARTI_mynode ;
      }
  }
}



